<cfcomponent displayname="SampleController" output="false" hint="I am a sample model-glue controller." extends="ModelGlue.Core.Controller">

<cffunction name="Init" access="Public" returnType="ContactManagerController" output="false" hint="I build a new SampleController">
  <cfargument name="ModelGlue">

  <cfscript>
  	super.Init(arguments.ModelGlue);
	variables.ContactManager = createObject("component", "dev.modelgluesamples.jquery.contactmanager.model.ContactManager");
	variables.RecentContactsManager = createObject("component", "dev.modelgluesamples.jquery.contactmanager.model.RecentContactsManager");
  </cfscript>

  <cfreturn this />
</cffunction>

<cffunction name="ListContacts" access="Public" returnType="ModelGlue.Core.Event" output="false" hint="I am an event handler.">
  <cfargument name="event" type="ModelGlue.Core.Event" required="true">
  <cfset arguments.event.setValue("contacts", GetContactManager().GetAllContacts()) />
  <cfreturn arguments.event />
</cffunction>

<cffunction name="GetContact" access="Public" returnType="ModelGlue.Core.Event" output="false" hint="I am an event handler.">
  <cfargument name="event" type="ModelGlue.Core.Event" required="true">

  <cfset var id = arguments.event.getValue("id") />

  <cfif len(id)>
    <cfset arguments.event.setValue("contact", GetContactManager().GetContact(id)) />
    <cfset arguments.event.addResult("success") />
  <cfelse>
    <cfset arguments.event.setValue("contact", GetContactManager().NewContact()) />
    <cfset arguments.event.addResult("success") />
  </cfif>


  <cfreturn arguments.event />
</cffunction>

<cffunction name="removeContact" access="Public" returnType="ModelGlue.Core.Event" output="false" hint="I am an event handler.">
  <cfargument name="event" type="ModelGlue.Core.Event" required="true">

  <cfset var id = arguments.event.getValue("id") />
  <cfset GetContactManager().removeContact(id) />

  <cfreturn arguments.event />
</cffunction>

<cffunction name="ShowContactForm" access="Public" returnType="ModelGlue.Core.Event" output="false" hint="I am an event handler.">
  <cfargument name="event" type="ModelGlue.Core.Event" required="true">

  <cfset id = arguments.event.getValue("contact").getId() />

  <cfif len(id)>
    <cfset arguments.event.setValue("submitLabel", "Update Contact") />
  <cfelse>
    <cfset arguments.event.setValue("submitLabel", "Add Contact") />
  </cfif>

  <cfreturn arguments.event />
</cffunction>

<cffunction name="CommitContact" access="Public" returnType="ModelGlue.Core.Event" output="false" hint="I am an event handler.">
  <cfargument name="event" type="ModelGlue.Core.Event" required="true">

  <cfset var contact = GetContactManager().NewContact() />
  <cfset var validation = "" />

  <!--- The makeEventBean() feature (line 83) replaces all of this!
  <cfif len(arguments.event.getValue("id"))>
    <cfset contact.setId(arguments.event.getValue("id")) />
  </cfif>
  <cfset contact.setFirstname(arguments.event.getValue("firstname")) />
  <cfset contact.setLastname(arguments.event.getValue("lastname")) />
  <cfset contact.setStreet(arguments.event.getValue("street")) />
  <cfset contact.setCity(arguments.event.getValue("city")) />
  <cfset contact.setState(arguments.event.getValue("state")) />
  <cfset contact.setZip(arguments.event.getValue("zip")) />
	--->

	<!--- makeEventBean() can take either a type (e.g., "com.myBean") or an instance --->
	<!---
				Example using type:
	<cfset contact = arguments.event.makeEventBean("modelgluesamples.contactmanager.model.Contact", "id,firstname,lastname,street,city,state,zip") />
	--->
	<!---
				Example using instance:
	--->
	<cfset contact = arguments.event.makeEventBean(contact, "id,firstname,lastname,street,city,state,zip") />
  <cfset validation = GetContactManager().CommitContact(contact) />

  <cfif validation.hasErrors()>
    <cfset arguments.event.addResult("invalid") />
    <cfset arguments.event.setValue("contactValidation", validation.getErrors()) />
    <cfset arguments.event.setValue("contact", contact) />
  <cfelse>
    <cfset getRecentContactsManager().addRecentContact(contact) />
    <cfset arguments.event.addResult("success") />
  </cfif>

  <cfreturn arguments.event />
</cffunction>

	<!--- Util --->
	<cffunction name="GetContactManager" access="private">
		<cfreturn variables.ContactManager>
	</cffunction>

	<cffunction name="GetRecentContactsManager" access="private">
		<cfreturn variables.RecentContactsManager>
	</cffunction>
</cfcomponent>